//=============================================================================
// UTent.Tent  - An Upside Down Tentacle thingy.  2015 - Mr.Loathsome
//=============================================================================
class Tent extends Tentacle;

function FlipRot()
	{
	local Rotator newRot;

//	log(Self@"FlipRot - Rotation = "$Rotation@"State"@GetStateName()@" - "@Enemy@Self.Physics);

	newRot = Rotation;

//  Use this if Rotation.Roll is actually used by the pawn.
//	if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//	else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }

	newRot.Roll = 32768;  // Tentacles never have Rotation.Roll at anything but zero.  This is faster.
	DesiredRotation = newRot;
	SetRotation(newRot);
}

function PreSetMovement()
{
	bCanJump = false;
	bCanWalk = false;
	bCanSwim = true;
	bCanFly = false;
	MinHitWall = -0.6;
	bCanOpenDoors = false;
	bCanDoSpecial = false;
//	log(self@"PreSetMovement called in state"@GetStateName()@"  -  "@self.rotation@Self.Physics);
	FlipRot();
}

function SetMovementPhysics();  // Never do this unless you are Loathsome.....

function SMPhysicsBork()
{
	if (Region.Zone.bWaterZone)
		SetPhysics(PHYS_Swimming);
	else
		SetPhysics(PHYS_Rotating); 
}

//   This DOES NOT modify TakeDamage.   Only uncomment the below function if you want to read the log file output.
/*
function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)

{
	log(self@"TakeDamage entry in state"@GetStateName()@" - "@instigatedBy@"  -  "@self.rotation@Self.Physics);
	Super.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
	log(self@"TakeDamage exit in state"@GetStateName()@" - "@instigatedBy@"  -  "@self.rotation@Self.Physics);

}
*/

function PlayDying(name DamageType, vector HitLocation)   // Beta1 - Under Construction....
{
//	log("PlayDying - "$Self@"Rotation = "$Rotation@Self.Physics);

	SMPhysicsBork();

	FlipRot();
	PlaySound(Die, SLOT_Talk, 3 * TransientSoundVolume);

	if ( Velocity.Z > 200 )
//		PlayAnim('Dead2', 0.7, 0.1);
		PlayAnim('All', 1.450 + (FRand()*3.0), 0.1250 + (FRand()*0.75));
	else
	{
//		PlayAnim('Dead1', 0.7, 0.1);
		PlayAnim('All', 1.450 + (FRand()*3.0), 0.1250 + (FRand()*0.75));
		SetPhysics(PHYS_None);
	}
}

function SmackTarget()
{
//	log("SmackTarget - "$Self@Target@" AnimSequence = "$AnimSequence$"  - Rotation = "$Rotation);
//	if ((Pawn(Target).Health > 0) && ( MeleeDamageTarget(WhipDamage, (WhipDamage * 1000 * Normal(Target.Location - Location))) ))
	if ((!Pawn(Target).IsA('Tentacle')) && (Pawn(Target).Health > 0) && ( MeleeDamageTarget(WhipDamage, (WhipDamage * 1000 * Normal(Target.Location - Location))) ))
		PlaySound(Whip, SLOT_Interact);		

}

function PlayRangedAttack()
{
	local vector projStart;

//	log("PlayRangedAttack - "$Self@"AnimSequence = "$AnimSequence$"  - Rotation = "$Rotation);

	FlipRot();
	MakeNoise(1.0); 
	projStart = Location - CollisionHeight * vect(0,0,-1.2);
	spawn(RangedProjectile ,self,'',projStart,AdjustAim(ProjectileSpeed, projStart, 900, bLeadTarget, bWarnTarget));
	PlayAnim('Shoot');
}

state Attacking
{
ignores SeePlayer, HearNoise, Bump, HitWall;

	function FlipR(Rotator newRot)
	{
//		if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//		else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }
		newRot.Roll = 32768;
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function ChooseAttackMode()
	{
		if (Physics == PHYS_Swimming)
		{
			Super.ChooseAttackMode();
			return;
		}
		if ((Enemy == None) || (Enemy.Health <= 0))
		{
			if ((OldEnemy != None) && (OldEnemy.Health > 0)) 
				{
				Enemy = OldEnemy;
				OldEnemy = None;
				}
			else
			{
				 GotoState('Waiting');
				 return;
			}
		}
			
		if (!LineOfSightTo(Enemy))
		{
			GotoState('StakeOut');
		}
		else
		{
			GotoState('RangedAttack');
		}

	}

	function BeginState()
	{
// log("State Attacking called - "$Self@Self.Rotation$" - "$Enemy);
		FlipR(Rotation);
	}
}

state RangedAttack
{
ignores SeePlayer, HearNoise, Bump;

	function FlipR(Rotator newRot)
	{
//		if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//		else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }
		newRot.Roll = 32768;
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
						Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'RangedAttack';
			NextLabel = 'Begin';
		}
	}

	function StopWaiting()
	{
		Timer();
	}

	function EnemyNotVisible()
	{
		////log("enemy not visible");
		//let attack animation completes
	}

	function KeepAttacking()
	{
		if ( !bFiringPaused && ((FRand() > ReFireRate) || (Enemy == None) || (Enemy.Health <= 0) || !CanFireAtEnemy()) ) 
			GotoState('Attacking');
	}

	function Timer()
	{
		if ( bFiringPaused )
		{
			TweenToRunning(0.12);
			GotoState(NextState, NextLabel);
		}
	}

	function AnimEnd()
	{
		GotoState('RangedAttack', 'DoneFiring');
	}
	
	function BeginState()
	{
		Target = Enemy;
		Disable('AnimEnd');
		bReadyToAttack = false;
		if ( bFiringPaused )
		{
			SetTimer(SpecialPause, false);
			SpecialPause = 0;
		}
	}
	
	function EndState()
	{
		bFiringPaused = false;
	}

Challenge:
	Disable('AnimEnd');
	Acceleration = vect(0,0,0); //stop
//	DesiredRotation = Rotator(Enemy.Location - Location);
//	SetRotation(DesiredRotation);
	FlipR(Rotator(Enemy.Location - Location));

	PlayChallenge();
	FinishAnim();
	if ( bCrouching && !Region.Zone.bWaterZone )
		Sleep(0.8 + FRand());
	bCrouching = false;
	TweenToFighter(0.1);
	Goto('FaceTarget');

Begin:
//log("State RangedAttack called - "$Self@" - "$Enemy);
	if ( Enemy == None )
		GotoState('Attacking');

	Acceleration = vect(0,0,0); //stop
//	DesiredRotation = Rotator(Enemy.Location - Location);
//	SetRotation(DesiredRotation);
	FlipR(Rotator(Enemy.Location - Location));


	TweenToFighter(0.15);
	
FaceTarget:
	Disable('AnimEnd');
	if (NeedToTurn(Enemy.Location))
	{
		PlayTurning();
		TurnToward(Enemy);
		TweenToFighter(0.1);
	}
	FinishAnim();

	if (VSize(Location - Enemy.Location) < 0.9 * MeleeRange + CollisionRadius + Enemy.CollisionRadius)
		GotoState('MeleeAttack', 'ReadyToAttack'); 

ReadyToAttack:
	if (!bHasRangedAttack)
		GotoState('Attacking');
//	DesiredRotation = Rotator(Enemy.Location - Location);
//	SetRotation(DesiredRotation);
	FlipR(Rotator(Enemy.Location - Location));

	PlayRangedAttack();
	Enable('AnimEnd');
Firing:
	if (Enemy == None )
		GotoState('Attacking');
	TurnToward(Enemy);
	Goto('Firing');
DoneFiring:
	Disable('AnimEnd');
	KeepAttacking();  
	Goto('FaceTarget');
}

state Acquisition
{
ignores falling, landed; //fixme

	function FlipR(Rotator newRot)
	{
//		if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//		else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }
		newRot.Roll = 32768;
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function WarnTarget(Pawn shooter, float projSpeed, vector FireDir)
	{
		local eAttitude att;

		if ( intelligence < BRAINS_Mammal )
			return;

		att = AttitudeTo(shooter);
		if ( ((att == ATTITUDE_Ignore) || (att == ATTITUDE_Threaten)) )
			damageAttitudeTo(shooter);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		LastSeenPos = Enemy.Location;
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'Attacking'; 
			NextLabel = 'Begin';
			GotoState('TakeHit'); 
		}
		else
			GotoState('Attacking');
	}
	
	function HearNoise(float Loudness, Actor NoiseMaker)
	{
		local vector OldLastSeenPos;
		
		if ( SetEnemy(NoiseMaker.instigator) )
		{
			OldLastSeenPos = LastSeenPos;
			if ( Enemy ==  NoiseMaker.instigator  )
				LastSeenPos = 0.5 * (NoiseMaker.Location + VSize(NoiseMaker.Location - Location) * vector(Rotation));
			else if ( (Pawn(NoiseMaker) != None) && (Enemy == Pawn(NoiseMaker).Enemy) )
				LastSeenPos = 0.5 * (Pawn(NoiseMaker).Enemy.Location + VSize(Pawn(NoiseMaker).Enemy.Location - Location) * vector(Rotation));
			if ( VSize(OldLastSeenPos - Enemy.Location) < VSize(LastSeenPos - Enemy.Location) )
				LastSeenPos = OldLastSeenPos;				
		}
		
	}
	
	function SeePlayer(Actor SeenPlayer)
	{
//	log(self@"SeePlayer in state Acquistion called - "@SeenPlayer@Enemy@"  -  "@self.rotation@Self.Physics);
		if ( SetEnemy(Pawn(SeenPlayer)) )
		{
			PlayAcquisitionSound();
			//log("Enemy Acquired!");
			MakeNoise(1.0);
			NextAnim = '';
			LastSeenPos = Enemy.Location;
			FlipR(Rotation);
			GotoState('Attacking');
		}
	} 
	
	function BeginState()
	{
// log("State Acquisition.BeginState called - "$Self@" - "$Enemy@Self.Rotation);
		Disable('Tick'); //only used for bounding anim time
		SetAlertness(-0.5);
		FlipR(Rotation);
	}
	
PlayOut:
// log("State Acquisition.PlayOut called - "$Self@" - "$Enemy@Self.Rotation);
	Acceleration = vect(0,0,0);
	if ( (AnimFrame < 0.6) && IsAnimating() )
	{
		Sleep(0.05);
		Goto('PlayOut');
	}
		
Begin:
// log("State Acquisition.Begin called - "$Self@" - "$Enemy@Self.Rotation);
//	SetMovementPhysics();
	SMPhysicsBork();

	//log("Acquiring enemy");
	////log("Enemy position = "$Enemy.Location);
	////log("Last seen position = "$LastSeenPos);
AcquTurn:
	Acceleration = vect(0,0,0);
	if (NeedToTurn(LastSeenPos))
	{	
		PlayTurning();
		TurnTo(LastSeenPos);
	}
//	DesiredRotation = Rotator(LastSeenPos - Location);
	FlipR(Rotator(LastSeenPos - Location));
	TweenToFighter(0.2); 
	FinishAnim();	
	////log("Stimulus = "$Stimulus);
	if ( AttitudeTo(Enemy) == ATTITUDE_Fear )  //will run away from noise
	{
		////log("Run away from noise");
		PlayFearSound();
		LastSeenPos = Enemy.Location; 
		MakeNoise(1.0);
		NextAnim = '';
		GotoState('Attacking');
	}
	else //investigate noise
	{
		////log("investigate noise");
		if ( pointReachable((Location + LastSeenPos) * 0.5) )
		{
			TweenToWalking(0.3);
			FinishAnim();
			PlayWalking();
//			PlayWalking();
//			MoveTo((Location + LastSeenPos) * 0.5, WalkingSpeed);
		PlayTurning();
		TurnTo(Location + LastSeenPos);
			Acceleration = vect(0,0,0);
		}
		WhatToDoNext('','');
	}
}

state StakeOut
{
ignores EnemyNotVisible; 

	function FlipR(Rotator newRot)
	{
//		if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//		else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }
		newRot.Roll = 32768;
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);

		if ( health <= 0 )
			return;
		if (NextState == 'TakeHit')
		{
			NextState = 'Attacking';
			NextLabel = 'Begin';
			GotoState('TakeHit'); 
		}
	}

Begin:
//log("State StakeOut.Begin called - "$Self@" - "$Enemy@Self.Rotation);
	TurnTo(LastSeenPos);
	FlipR(Rotation);
HangOut:
//log("State StakeOut.HangOut called - "$Self@" - "$Enemy@Self.Rotation);
	FinishAnim();
	PlayChallenge();
	Sleep(1 + FRand());
	if ( FRand() < 0.1250 )
	{
		PlayWaiting();
		GotoState('Waiting');
	}
	else
		LoopAnim('Waver');
	Goto('HangOut');
}

state Waiting
{
	function FlipR(Rotator newRot)
	{
//		if (newRot.Roll > 49152) { newRot.Roll -= 32768; }
//		else
//		if (newRot.Roll < 16384) { newRot.Roll += 32768; }
		newRot.Roll = 32768;
		DesiredRotation = newRot;
		SetRotation(newRot);
	}

	function TakeDamage( int Damage, Pawn instigatedBy, Vector hitlocation, 
							Vector momentum, name damageType)
	{
		Global.TakeDamage(Damage, instigatedBy, hitlocation, momentum, damageType);
		if ( health <= 0 )
			return;
		if ( Enemy != None )
			LastSeenPos = Enemy.Location;
		if (NextState == 'TakeHit')
		{
			NextState = 'Attacking'; 
			NextLabel = 'Begin';
			GotoState('TakeHit'); 
		}
		else if ( Enemy != None )
			GotoState('Attacking');
	}

	function Bump(actor Other)
	{
		//log(Other.class$" bumped "$class);
		if (Pawn(Other) != None)
		{
			if (Enemy == Other)
				bReadyToAttack = True; //can melee right away
			SetEnemy(Pawn(Other));
		}
		if ( TimerRate <= 0 )
			setTimer(1.5, false);
		Disable('Bump');
	}
	
	function Timer()
	{
		Enable('Bump');
	}
	
	function EnemyAcquired()
	{
		GotoState('Acquisition', 'PlayOut');
	}
	
	function AnimEnd()
	{
		PlayWaiting();
		bStasis = true;
	}
 
	function Landed(vector HitNormal)
	{
// log("State Waiting.Landed called - "$Self@" - "$Enemy@Self.Rotation@Self.Physics);
		SetPhysics(PHYS_None);
	}

	function BeginState()
	{
		Enemy = None;
		bStasis = false;
		Acceleration = vect(0,0,0);
		SetAlertness(0.0);
// log("State Waiting.BeginState called - "$Self@" - "$Enemy@Self.Rotation@Self.Physics);
	}

TurnFromWall:
	if ( NearWall(2 * CollisionRadius + 50) )
	{
		PlayTurning();
		TurnTo(Focus);
	}
Begin:
// log("State Waiting.Begin called - "$Self@" - "$Enemy@Self.Rotation@Self.Physics);
	TweenToWaiting(0.4);
	bReadyToAttack = false;
	DesiredRotation = rot(0,0,0);
	DesiredRotation.Yaw = Rotation.Yaw;
//	SetRotation(DesiredRotation);
	if (Physics != PHYS_Falling) 
		SetPhysics(PHYS_None);
	FlipR(DesiredRotation);
KeepWaiting:
	NextAnim = '';
}

//     RangedProjectile=Class'UTent.TentProjectile'

defaultproperties
{
     WhipDamage=20
     Health=100
     MeleeRange=200.000000
     MenuName="UTent"
}
